#include "lexico.h"
#include "sintatico.h"

// Variaveis globais
static FILE *arquivoFonte;
char nomeArquivoFonte[256];
char caracter;
char aux[80];
static bool flag = 0;


/*
	Trata palavra reservada
	Entrada: token
	Retorno: token
*/
token *trataPalavra(token *node)
{
	strncpy(aux, &caracter, 1);
	fread(&caracter, sizeof(char), 1, arquivoFonte);
	
	while (caracter >= 65 && caracter <= 90 || caracter >= 97 && caracter <= 122 || caracter >= 48 && caracter <= 57 || caracter == 95) {
		strncat(aux,&caracter,1);
		fread(&caracter, sizeof(char), 1, arquivoFonte);
	}

	strcpy(node->lexema,aux);

	if (strcmp(aux,"programa") == 0) {
		node->id = 31; 
	}
	else 		
		if (strcmp(aux,"fim") == 0)	{
			node->id = 33; 
		}
	else
		if (strcmp(aux,"inicio") == 0)	{
		node->id = 32; 
		}
	else
		if (strcmp(aux,"fim") == 0)	{
		node->id = 33; 
		}
	else
		if (strcmp(aux,"procedimento") == 0) {
			node->id = 34; 
		}
	else 
		if (strcmp(aux,"funcao") == 0) {
			node->id = 35; 
		}
	else 
		if (strcmp(aux,"se") == 0) {
			node->id = 36; 
		}
	else
		if (strcmp(aux,"entao") == 0) {
			node->id = 37; 
		}
	else
		if (strcmp(aux,"senao") == 0) {
			node->id = 38; 
		}
	else
		if (strcmp(aux,"enquanto") == 0) {
			node->id = 39; 
		}
	else 
		if (strcmp(aux,"faca") == 0) {
			node->id = 40; 
		}
	else
		if (strcmp(aux,"escreva") == 0) {
			node->id = 41; 
		}
	else 
		if (strcmp(aux,"leia") == 0) {
			node->id = 42; 
		}
	else
		if (strcmp(aux,"var") == 0) {
			node->id = 43; 
		}
	else
		if (strcmp(aux,"inteiro") == 0) {
			node->id = 44; 
		}
	else
		if (strcmp(aux,"booleano") == 0) {
			node->id = 45; 
		}
	else
		if (strcmp(aux,"div") == 0) {
			node->id = 74; 
		}
	else
		if (strcmp(aux,"e") == 0) {
			node->id = 81; 
		}
	else
		if (strcmp(aux,"ou") == 0) {
			node->id = 82; 
		}
	else
		if (strcmp(aux,"nao") == 0) {
			node->id = 83; 
		}
	else
		if (strcmp(aux, "verdadeiro") == 0) {
			node->id = 46;
        }
	else
		if (strcmp(aux, "falso") == 0) {
			node->id = 47;
        }
	else {
		node->id = 90; 	// identificador
	}
	
	return node;
}


/*
	Funcao que trata numero
	Entrada: token
	Retorno: token
*/
token *trataNumero(token *node)
{
	strncpy(aux,&caracter,1);
	fread(&caracter, sizeof(char), 1, arquivoFonte);
	
	while (caracter >= 48 && caracter <= 57) {
		strncat(aux,&caracter,1);
		fread(&caracter, sizeof(char), 1, arquivoFonte);
	}

	strcpy(node->lexema,aux);
	node->id = 91;
	return node;
}


/*
	Funcao que trata atribuicao
	Entrada: token
	Retorno: token
*/
token *trataAtribuicao(token *node)
{
	fread(&caracter, sizeof(char), 1, arquivoFonte);

	if (caracter == '=') {
		strcpy(node->lexema,":=");
		node->id = 50;
		fread(&caracter, sizeof(char), 1, arquivoFonte);
	}
	else {
		strcpy(node->lexema,":");
		node->id = 56;
	}
	
	return node;
}


/*
	Funcao que trata pontuacao
	Entrada: token
	Retorno: token
*/
token *trataPontuacao(token *node)
{
	strncpy(aux, &caracter, 1);
	strcpy(node->lexema, aux);

	if (strcmp(aux,";") == 0) {
			node->id = 52;
	}
	else
		if (strcmp(aux,"(") == 0) {
			node->id = 54;
		}
		else
			if (strcmp(aux,")") == 0) {
				node->id = 55;
			}
			else
				if (strcmp(aux,",") == 0) {
					node->id = 53;
				}
				else
					if (strcmp(aux,".") == 0) {
						node->id = 51;
					}
	
	fread(&caracter, sizeof(char), 1, arquivoFonte);
	return node;
}


/*
	Funcao que trata operadores relacionais
	Entrada: token
	Retorno: token
*/
token *trataOperadoresRelacionais(token *node)
{
	strncpy(aux, &caracter, 1);

	if (caracter == '>') { 
		fread(&caracter, sizeof(char), 1, arquivoFonte);
		if (caracter == '=') { 
			strncat(aux, &caracter, 1);
			node->id = 62;
			fread(&caracter, sizeof(char), 1, arquivoFonte);
		}
		else{
			node->id = 61;
		}
	}
	else
		if (caracter == '<') { 
			fread(&caracter, sizeof(char), 1, arquivoFonte);
			
			if (caracter == '=') { 
				strncat(aux,&caracter,1);
				node->id = 65; 
				fread(&caracter, sizeof(char), 1, arquivoFonte);
			}
			else
				if (caracter == '>' ){
					strncat(aux,&caracter,1);
					node->id = 66;
					fread(&caracter, sizeof(char), 1, arquivoFonte);
				}
				else {
					node->id = 64; 
				}		
		}
		else {
			node->id = 63;
			fread(&caracter, sizeof(char), 1, arquivoFonte);
		}
	
	strcpy(node->lexema,aux);
	return node;
}


/*
	Funcao que trata operadores aritimeticos
	Entrada: token
	Retorno: token
*/
token *trataOperadoresAritimeticos(token *node)
{
	strncpy(aux,&caracter,1);

	if (caracter == '+') { 
		node->id = 71;
	}	
	else
		if (caracter == '-') { 
			node->id = 72;
		}
		else
			if (caracter == '*') { 
				node->id = 73;
			}
	
	strcpy(node->lexema,aux);
	fread(&caracter, sizeof(char), 1, arquivoFonte);

	return node;
}

/*
	Funcao que retorna um token do fonte (arquivo texto)
	Entrada: variavel que recebe o token
	Retorno: variavel de entrada contendo o token
*/
token *getToken(token *node)
{
	bool flag_loop = 0;
	int count = 0, aux_line=0;
	
	if(flag == 0) {
		node->line = 0;
		
		// arquivo fonte
		arquivoFonte = fopen(nomeArquivoFonte, "r");

		if(arquivoFonte == NULL) {
			printf("Falha ao abrir arquivo fonte!\n");
			exit(1);
		}

		// le do arquivo 1 byte
		fread(&caracter, sizeof(char), 1, arquivoFonte);
		flag = 1;
	}

	// le todo o arquivo
	while( !feof(arquivoFonte) ) {
		memset(aux,NULL,sizeof(aux));

		// nao le caracteres especiais (espaco, tab, etc)
		if (caracter == SPACE || caracter == TAB) {
			while (caracter == SPACE || caracter == TAB) {
				fread(&caracter, sizeof(char), 1, arquivoFonte);
			}
			flag_loop = 1;
		}
		else 
			if (caracter == LINE_FEED || caracter == CARRIAGE_RETURN) {
				if(caracter == LINE_FEED)
					node->line++;
				
				fread(&caracter, sizeof(char), 1, arquivoFonte);
				flag_loop = 1;
			}
			else
				// trata comentario
				if (caracter == '{') {
					aux_line = node->line;
					
					while (caracter != '}' && !feof(arquivoFonte)) {
						fread(&caracter, sizeof(char), 1, arquivoFonte);
						if(caracter == LINE_FEED)
							node->line++;
						
						if(feof(arquivoFonte)) {
							char error[256];
							node->id = -1;
							sprintf(error, "LINHA(%d) ERRO! Comentrio sem fim! ", aux_line);
							strcpy(node->error, error);
							node->line = aux_line;
							return node;
						}
				}
			fread(&caracter, sizeof(char), 1, arquivoFonte);
			flag_loop = 1;
		}
		
		else
			// trata palavras reservadas a ate z
			if (caracter >= 65 && caracter <= 90 || caracter >= 97 && caracter <= 122) {
				flag_loop = 0;
				return trataPalavra(node);
			}
			else
				// trata digitos numericos
				if (caracter >= 48 && caracter <= 57) {
					flag_loop = 0;
					return trataNumero(node);
				}
				else 
					// trata atribuicao
					if (caracter == 58) {
						flag_loop = 0;
						return trataAtribuicao(node);
					}
				else
					// trata pontuacao
					if (caracter == 40 || caracter == 41 || caracter == 44 || caracter == 46 || caracter == 59) {
						flag_loop = 0;
						return trataPontuacao(node);
					}
				else
					// trata operadores relacionais
					if (caracter >= 60 && caracter <= 62) {
						flag_loop = 0;
						return trataOperadoresRelacionais(node);
					}
				else
					// trata operadores aritimeticos
					if (caracter == 42 || caracter == 43 || caracter == 45) {
						flag_loop = 0;
						return trataOperadoresAritimeticos(node);
					}
				// erro
				else  {
					flag_loop = 0;
					strncpy(aux,&caracter,1);
					strcpy(node->lexema,aux);//guarda o lexema no novo n
					node->id = 0; //guarda o id no novo n
					fread(&caracter, sizeof(char), 1, arquivoFonte);
					memset(node, 0, sizeof(token));
				}
	}
	
	if(feof(arquivoFonte))
		memset(node, 0, sizeof(token));

	return node;
}


void trocarNomeArquivo(char *arquivo)
{
	strcpy(nomeArquivoFonte, arquivo);
}


void fecharArquivo()
{
	fclose(arquivoFonte);
	flag = 0;
}
